# Uses of Interface
com.sun.source.doctree.DocTree

Packages that use DocTree
Package
Description
com.sun.source.doctree
Provides interfaces to represent documentation comments as abstract syntax trees (AST).
com.sun.source.util
Provides utilities for operations on abstract syntax trees (AST).
jdk.javadoc.doclet
The Doclet API provides an environment which, in conjunction with the Language Model API and Compiler Tree API, allows clients to inspect the source-level structures of programs and libraries, including API comments embedded in the source.

## Uses of DocTree in com.sun.source.doctree

Subinterfaces of DocTree in com.sun.source.doctree
Modifier and Type
Interface
Description
`interface`
`AttributeTree`
A tree node for an attribute in an HTML element or tag.
`interface`
`AuthorTree`
A tree node for an `@author` block tag.
`interface`
`BlockTagTree`
A tree node used as the base class for the different types of block tags.
`interface`
`CommentTree`
An embedded HTML comment.
`interface`
`DeprecatedTree`
A tree node for an `@deprecated` block tag.
`interface`
`DocCommentTree`
The top-level representation of a documentation comment.
`interface`
`DocRootTree`
A tree node for an `@docRoot` inline tag.
`interface`
`DocTypeTree`
A tree node for a `doctype` declaration.
`interface`
`EndElementTree`
A tree node for the end of an HTML element.
`interface`
`EntityTree`
A tree node for an HTML entity.
`interface`
`ErroneousTree`
A tree node to stand in for malformed text.
`interface`
`EscapeTree`
A tree node for a character represented by an escape sequence.
`interface`
`HiddenTree`
A tree node for an `@hidden` block tag.
`interface`
`IdentifierTree`
An identifier in a documentation comment.
`interface`
`IndexTree`
A tree node for an `@index` inline tag.
`interface`
`InheritDocTree`
A tree node for an `@inheritDoc` inline tag.
`interface`
`InlineTagTree`
A tree node used as the base class for the different types of inline tags.
`interface`
`LinkTree`
A tree node for an `@link` or `@linkplain` inline tag.
`interface`
`LiteralTree`
A tree node for an `@literal` or `@code` inline tag.
`interface`
`ParamTree`
A tree node for an `@param` block tag.
`interface`
`ProvidesTree`
A tree node for a `@provides` block tag.
`interface`
`RawTextTree`
A tree node for a fragment of uninterpreted raw text content.
`interface`
`ReferenceTree`
A tree node for a reference to a Java language element.
`interface`
`ReturnTree`
A tree node for an `@return` block tag.
`interface`
`SeeTree`
A tree node for an `@see` block tag.
`interface`
`SerialDataTree`
A tree node for an `@serialData` block tag.
`interface`
`SerialFieldTree`
A tree node for an `@serialField` block tag.
`interface`
`SerialTree`
A tree node for an `@serial` block tag.
`interface`
`SinceTree`
A tree node for an `@since` block tag.
`interface`
`SnippetTree`
A tree node for an `@snippet` inline tag.
`interface`
`SpecTree`
A tree node for an `@spec` block tag.
`interface`
`StartElementTree`
A tree node for the start of an HTML element.
`interface`
`SummaryTree`
A tree node for an `@summary` inline tag.
`interface`
`SystemPropertyTree`
A tree node for an `@systemProperty` inline tag.
`interface`
`TextTree`
A tree node for plain text.
`interface`
`ThrowsTree`
A tree node for an `@exception` or `@throws` block tag.
`interface`
`UnknownBlockTagTree`
A tree node for an unrecognized block tag.
`interface`
`UnknownInlineTagTree`
A tree node for an unrecognized inline tag.
`interface`
`UsesTree`
A tree node for an `@uses` block tag.
`interface`
`ValueTree`
A tree node for an `@value` inline tag.
`interface`
`VersionTree`
A tree node for an `@version` block tag.
Methods in com.sun.source.doctree that return DocTree
Modifier and Type
Method
Description
`DocTree`
IndexTree.`getSearchTerm()`
Returns the specified search term.
Methods in com.sun.source.doctree that return types with arguments of type DocTree
Modifier and Type
Method
Description
`List<? extends DocTree>`
SnippetTree.`getAttributes()`
Returns the list of the attributes of the `@snippet` tag.
`List<? extends DocTree>`
StartElementTree.`getAttributes()`
Returns any attributes defined by this element.
`List<? extends DocTree>`
DocCommentTree.`getBlockTags()`
Returns the block tags for a documentation comment.
`List<? extends DocTree>`
DeprecatedTree.`getBody()`
Returns the description explaining why an item is deprecated.
`List<? extends DocTree>`
DocCommentTree.`getBody()`
Returns the body of a documentation comment, appearing after the first sentence, and before any block tags.
`List<? extends DocTree>`
HiddenTree.`getBody()`
Returns the description explaining why an item is hidden.
`List<? extends DocTree>`
SinceTree.`getBody()`
Returns the text explaining the availability of the item being documented.
`List<? extends DocTree>`
VersionTree.`getBody()`
Returns the body of the tag.
`List<? extends DocTree>`
UnknownBlockTagTree.`getContent()`
Returns the content of an unrecognized block tag.
`List<? extends DocTree>`
UnknownInlineTagTree.`getContent()`
Returns the content of an unrecognized inline tag.
`List<? extends DocTree>`
IndexTree.`getDescription()`
Returns the description, if any.
`List<? extends DocTree>`
ParamTree.`getDescription()`
Returns the description of the parameter.
`List<? extends DocTree>`
ProvidesTree.`getDescription()`
Returns a description of the service type being provided by the module.
`List<? extends DocTree>`
ReturnTree.`getDescription()`
Returns the description of the return value of a method.
`List<? extends DocTree>`
SerialDataTree.`getDescription()`
Returns the description of the serial data.
`List<? extends DocTree>`
SerialFieldTree.`getDescription()`
Returns the description of the serial field.
`List<? extends DocTree>`
SerialTree.`getDescription()`
Returns the description of the field, or the word "include" or "exclude".
`List<? extends DocTree>`
ThrowsTree.`getDescription()`
Returns a description of the reasons why the exception may be thrown.
`List<? extends DocTree>`
UsesTree.`getDescription()`
Returns a description of the use of service type within the module.
`List<? extends DocTree>`
DocCommentTree.`getFirstSentence()`
Returns the first sentence of a documentation comment.
`default List<? extends DocTree>`
DocCommentTree.`getFullBody()`
Returns the entire body of a documentation comment, appearing before any block tags, including the first sentence.
`List<? extends DocTree>`
LinkTree.`getLabel()`
Returns the label, if any, of the link.
`List<? extends DocTree>`
AuthorTree.`getName()`
Returns the name of the author.
`default List<? extends DocTree>`
DocCommentTree.`getPostamble()`
Returns a list of trees containing the content (if any) following the content of the documentation comment.
`default List<? extends DocTree>`
DocCommentTree.`getPreamble()`
Returns a list of trees containing the content (if any) preceding the content of the documentation comment.
`List<? extends DocTree>`
SeeTree.`getReference()`
Returns the reference.
`List<? extends DocTree>`
SummaryTree.`getSummary()`
Returns the summary or the first line of a comment.
`List<? extends DocTree>`
SpecTree.`getTitle()`
Returns the title.
`List<? extends DocTree>`
AttributeTree.`getValue()`
Returns the value of the attribute, or `null` if the kind of this attribute is `EMPTY`.
Methods in com.sun.source.doctree with parameters of type DocTree
Modifier and Type
Method
Description
`R`
DocTreeVisitor.`visitOther(DocTree node, P p)`
Visits an unknown type of `DocTree` node.

## Uses of DocTree in com.sun.source.util

Classes in com.sun.source.util that implement interfaces with type arguments of type DocTree
Modifier and Type
Class
Description
`class`
`DocTreePath`
A path of tree nodes, typically used to represent the sequence of ancestor nodes of a tree node up to the top-level `DocCommentTree` node.
Methods in com.sun.source.util that return DocTree
Modifier and Type
Method
Description
`DocTree`
DocTreePath.`getLeaf()`
Returns the leaf node for this path.
Methods in com.sun.source.util that return types with arguments of type DocTree
Modifier and Type
Method
Description
`List<DocTree>`
DocTreeFactory.`getFirstSentence(List<? extends DocTree> list)`
Gets the first sentence contained in a list of content.
`abstract List<DocTree>`
DocTrees.`getFirstSentence(List<? extends DocTree> list)`
Returns the list of `DocTree` representing the first sentence of a comment.
`Iterator<DocTree>`
DocTreePath.`iterator()`
Methods in com.sun.source.util with parameters of type DocTree
Modifier and Type
Method
Description
`protected R`
SimpleDocTreeVisitor.`defaultAction(DocTree node, P p)`
The default action, used by all visit methods that are not overridden.
`long`
DocSourcePositions.`getEndPosition(CompilationUnitTree file, DocCommentTree comment, DocTree tree)`
Returns the ending position of the tree within the comment within the file.
`static DocTreePath`
DocTreePath.`getPath(DocTreePath path, DocTree target)`
Returns a documentation tree path for a tree node within a subtree identified by a `DocTreePath` object, or `null` if the node is not found.
`static DocTreePath`
DocTreePath.`getPath(TreePath treePath, DocCommentTree doc, DocTree target)`
Returns a documentation tree path for a tree node within a compilation unit, or `null` if the node is not found.
`long`
DocSourcePositions.`getStartPosition(CompilationUnitTree file, DocCommentTree comment, DocTree tree)`
Returns the starting position of the tree within the comment within the file.
`IndexTree`
DocTreeFactory.`newIndexTree(DocTree term, List<? extends DocTree> description)`
Creates a new `IndexTree` object, to represent an `{@index }` tag.
`abstract void`
DocTrees.`printMessage(Diagnostic.Kind kind, CharSequence msg, DocTree t, DocCommentTree c, CompilationUnitTree root)`
Prints a message of the specified kind at the location of the tree within the provided compilation unit.
`R`
DocTreePathScanner.`scan(DocTree tree, P p)`
Scans a single node.
`R`
DocTreeScanner.`scan(DocTree node, P p)`
Scans a single node.
`final R`
SimpleDocTreeVisitor.`visit(DocTree node, P p)`
Invokes the appropriate visit method specific to the type of the node.
`R`
DocTreeScanner.`visitOther(DocTree node, P p)`
Visits an unknown type of `DocTree` node.
`R`
SimpleDocTreeVisitor.`visitOther(DocTree node, P p)`
Visits an unknown type of `DocTree` node.
Method parameters in com.sun.source.util with type arguments of type DocTree
Modifier and Type
Method
Description
`List<DocTree>`
DocTreeFactory.`getFirstSentence(List<? extends DocTree> list)`
Gets the first sentence contained in a list of content.
`abstract List<DocTree>`
DocTrees.`getFirstSentence(List<? extends DocTree> list)`
Returns the list of `DocTree` representing the first sentence of a comment.
`AttributeTree`
DocTreeFactory.`newAttributeTree(Name name, AttributeTree.ValueKind vkind, List<? extends DocTree> value)`
Creates a new `AttributeTree` object, to represent an attribute in an HTML element or tag.
`AuthorTree`
DocTreeFactory.`newAuthorTree(List<? extends DocTree> name)`
Creates a new `AuthorTree` object, to represent an `@author` tag.
`DeprecatedTree`
DocTreeFactory.`newDeprecatedTree(List<? extends DocTree> text)`
Creates a new `DeprecatedTree` object, to represent an `@deprecated` tag.
`DocCommentTree`
DocTreeFactory.`newDocCommentTree(List<? extends DocTree> fullBody, List<? extends DocTree> tags)`
Creates a new `DocCommentTree` object, to represent a complete doc comment.
`DocCommentTree`
DocTreeFactory.`newDocCommentTree(List<? extends DocTree> fullBody, List<? extends DocTree> tags, List<? extends DocTree> preamble, List<? extends DocTree> postamble)`
Creates a new `DocCommentTree` object, to represent the entire doc comment.
`ThrowsTree`
DocTreeFactory.`newExceptionTree(ReferenceTree name, List<? extends DocTree> description)`
Creates a new `ThrowsTree` object, to represent an `@exception` tag.
`HiddenTree`
DocTreeFactory.`newHiddenTree(List<? extends DocTree> text)`
Creates a new `HiddenTree` object, to represent an `@hidden` tag.
`IndexTree`
DocTreeFactory.`newIndexTree(DocTree term, List<? extends DocTree> description)`
Creates a new `IndexTree` object, to represent an `{@index }` tag.
`LinkTree`
DocTreeFactory.`newLinkPlainTree(ReferenceTree ref, List<? extends DocTree> label)`
Creates a new `LinkTree` object, to represent a `{@linkplain }` tag.
`LinkTree`
DocTreeFactory.`newLinkTree(ReferenceTree ref, List<? extends DocTree> label)`
Creates a new `LinkTree` object, to represent a `{@link }` tag.
`ParamTree`
DocTreeFactory.`newParamTree(boolean isTypeParameter, IdentifierTree name, List<? extends DocTree> description)`
Creates a new `ParamTree` object, to represent a `@param` tag.
`ProvidesTree`
DocTreeFactory.`newProvidesTree(ReferenceTree name, List<? extends DocTree> description)`
Creates a new `ProvidesTree` object, to represent a `@provides` tag.
`default ReturnTree`
DocTreeFactory.`newReturnTree(boolean isInline, List<? extends DocTree> description)`
Creates a new `ReturnTree` object, to represent a `@return` tag or `{@return}` tag.
`ReturnTree`
DocTreeFactory.`newReturnTree(List<? extends DocTree> description)`
Creates a new `ReturnTree` object, to represent a `@return` tag.
`SeeTree`
DocTreeFactory.`newSeeTree(List<? extends DocTree> reference)`
Creates a new `SeeTree` object, to represent a `@see` tag.
`SerialDataTree`
DocTreeFactory.`newSerialDataTree(List<? extends DocTree> description)`
Creates a new `SerialDataTree` object, to represent a `@serialData` tag.
`SerialFieldTree`
DocTreeFactory.`newSerialFieldTree(IdentifierTree name, ReferenceTree type, List<? extends DocTree> description)`
Creates a new `SerialFieldTree` object, to represent a `@serialField` tag.
`SerialTree`
DocTreeFactory.`newSerialTree(List<? extends DocTree> description)`
Creates a new `SerialTree` object, to represent a `@serial` tag.
`SinceTree`
DocTreeFactory.`newSinceTree(List<? extends DocTree> text)`
Creates a new `SinceTree` object, to represent a `@since` tag.
`SnippetTree`
DocTreeFactory.`newSnippetTree(List<? extends DocTree> attributes, TextTree text)`
Creates a new `SnippetTree` object, to represent a `{@snippet }` tag.
`SpecTree`
DocTreeFactory.`newSpecTree(TextTree url, List<? extends DocTree> title)`
Creates a new `SpecTree` object, to represent an `@spec` tag.
`StartElementTree`
DocTreeFactory.`newStartElementTree(Name name, List<? extends DocTree> attrs, boolean selfClosing)`
Creates a new `StartElementTree` object, to represent the start of an HTML element.
`default SummaryTree`
DocTreeFactory.`newSummaryTree(List<? extends DocTree> summary)`
Creates a new `SummaryTree` object, to represent a `{@summary }` tag.
`ThrowsTree`
DocTreeFactory.`newThrowsTree(ReferenceTree name, List<? extends DocTree> description)`
Creates a new `ThrowsTree` object, to represent a `@throws` tag.
`UnknownBlockTagTree`
DocTreeFactory.`newUnknownBlockTagTree(Name name, List<? extends DocTree> content)`
Creates a new `UnknownBlockTagTree` object, to represent an unrecognized block tag.
`UnknownInlineTagTree`
DocTreeFactory.`newUnknownInlineTagTree(Name name, List<? extends DocTree> content)`
Creates a new `UnknownInlineTagTree` object, to represent an unrecognized inline tag.
`UsesTree`
DocTreeFactory.`newUsesTree(ReferenceTree name, List<? extends DocTree> description)`
Creates a new `UsesTree` object, to represent a `@uses` tag.
`VersionTree`
DocTreeFactory.`newVersionTree(List<? extends DocTree> text)`
Creates a new `VersionTree` object, to represent a `{@version }` tag.
`R`
DocTreeScanner.`scan(Iterable<? extends DocTree> nodes, P p)`
Scans a sequence of nodes.
`final R`
SimpleDocTreeVisitor.`visit(Iterable<? extends DocTree> nodes, P p)`
Invokes the appropriate visit method on each of a sequence of nodes.
Constructors in com.sun.source.util with parameters of type DocTree
Modifier
Constructor
Description
``
`DocTreePath(DocTreePath p, DocTree t)`
Creates a `DocTreePath` for a child node.

## Uses of DocTree in jdk.javadoc.doclet

Method parameters in jdk.javadoc.doclet with type arguments of type DocTree
Modifier and Type
Method
Description
`String`
Taglet.`toString(List<? extends DocTree> tags, Element element)`
Returns the string representation of a series of instances of this tag to be included in the generated output.